% Routine to create a bifacial lens given the radii of
% curvature, central thickness and centre position.
% 21/7/96 Now ask for refractive index option
% -----------------------------------------------------
% Define some variables
% -----------------------------------------------------
.=> CENTREX
.=> CENTREY
.=> R1
.=> R2
.=> HEIGHT
.=> CHORD
% -----------------------------------------------------
% First get design values
% -----------------------------------------------------
.enable_undo 0
.grid_snap 0
:NEWVALUES
.new_text
Click where you want the lens centred.


Remember that you can use an absolute coordinate snap or
other snap to specify coordinates exactly by clicking on
the secondary mouse button and choosing from the popup menu.
% -----------------------------------------------------
% Get the user to choose a centre point
% -----------------------------------------------------
.user_click
.CENTREX lastclick.x
.CENTREY lastclick.y
% -----------------------------------------------------
% Get the radii of curvature for the faces
% -----------------------------------------------------
.input_limits -10000 10000
.default_input 200
.new_text
Enter the radius of curvature of the first surface.

Enter 0 for a plane surface.
.R1 userinput
.+/- R1
.default_input
.new_text
Enter the radius of curvature of the second surface.

Enter 0 for a plane surface.
.R2 userinput
% -----------------------------------------------------
% Get a height for the lens
% -----------------------------------------------------
.new_text
Enter the height of the lens.

Values between 10 and 200 please.
.input_limits 10 200
.default_input 100
.HEIGHT userinput
% -----------------------------------------------------
% Get a central thickness for the lens
% -----------------------------------------------------
.call findthck.rsc
.new_text
Enter the central thickness of the lens.

Values between 1 and 100 please.
.default_input THICK
.input_limits 1 100
.THICK userinput
% -----------------------------------------------------
% Check the users values before proceeding
% -----------------------------------------------------
.new_text
You have entered the values:

    Lens centre coordinates:
.printf %5.2f CENTREX
,
.printf %5.2f CENTREY

    Radius of first surface:
.printf %5.2f R1

    Radius of second surface:
.printf %5.2f R2

    Lens thickness:
.printf %4.2f THICK

    Lens height:
.printf %4.2f HEIGHT


Ok? Click on No to go back and reenter the values.
.yes_no OKVALUES NEWVALUES
:OKVALUES
.new_text
Please wait a few moments while the lens is constructed.
.painting 0
.recalc 0
.call mklens.rsc
.recalc 1
.painting 1
% --------------------------------------------------------
% Check that all is OK
% --------------------------------------------------------
.new_text
Is the result as you expected? Click on No to to
delete this lens and start again?
.yes_no LENSOK RETRY
:RETRY
.select_object LENS
.delete
.goto NEWVALUES
:LENSOK
% --------------------------------------------------------
% Option to change refractive index
% --------------------------------------------------------
.new_text
The refractive indices of the lens have been set to the
current default values. Do you want to specify a new
refractive index?
.yes_no CHANGER EXIT
:CHANGER
.call getior.rsc
.painting 0
.unselect_all
.select_object LENS
.refractive_index N_RED N_GREEN N_BLUE
.unselect_all
.painting 1
:EXIT
.enable_undo 1
.return
