% Creates a system consisting of two thin lenses
.file_new
.enable_undo 0
.quiet_snap 1
.grid_snap 0
.red
.=> FIRSTX
.=> SECONDX
.=> FIRSTY
.=> FLEN1
.=> HEIGHT1
.=> LENS1
.=> SEP
.=> FLEN2
.=> HEIGHT2
.=> LENS2
.=> TEMP
.=> SRCX
.=> SRCY
.=> PLANESRC
.new_text
This script sets up a system of two thin lenses.


Is this what you want to do?
.yes_no DOIT END
:DOIT
.new_text
Click where you want the centre of the first lens.
.user_click
.FIRSTX lastclick.x
.FIRSTY lastclick.y
.new_text
Enter the focal length of the first lens.
.input_limits 10 10000
.default_input 30
.FLEN1 userinput
.new_text
Enter the height of the first lens.
.input_limits 10 300
.default_input 50
.HEIGHT1 userinput
.FIRSTX
.+ FLEN1
.=> TEMP
.paraxials_on_centre 1
.converging_lens
.fast_click FIRSTX FIRSTY
.fast_click_rel 0 HEIGHT1
.fast_click TEMP FIRSTY
.=> LENS1
.new_text
Enter the distance between the lenses.
.default_input 150
.input_limits 10 1000
.SEP userinput
.FIRSTX
.+ SEP
.=> SECONDX
.new_text
Enter the focal length of the second lens.
.default_input 50
.FLEN2 userinput
.new_text
Enter the height of the second lens.
.input_limits 10 300
.default_input 80
.HEIGHT2 userinput
.SECONDX
.+ FLEN2
.=> TEMP
.converging_lens
.fast_click SECONDX FIRSTY
.fast_click_rel 0 HEIGHT2
.fast_click TEMP FIRSTY
.=> LENS2
.new_text
Do you want the lenses locked to the axis?


If you choose YES then the lenses can only be moved along
the x direction.
.yes_no LOCKTHEM NOLOCKS
:LOCKTHEM
.select_object LENS1
.select_object LENS2
.lock_y
:NOLOCKS
.unselect_all
.new_text
Do you want to create a source of rays?
.yes_no MAKESOURCE END
:MAKESOURCE
.PLANESRC 0
.new_text
Click on A for a point source.


Click on B for a plane source.
.choose 2 A1 B1
:B1
.PLANESRC 1
:A1
.new_text
How many rays do you want coming from the source?
.default_input 3
.input_limits 1 10
.source_ray_count userinput
.PLANESRC
.if!= 0 PLANE
.new_text
Click where you want the object point located.
.user_click
.SRCX lastclick.x
.SRCY lastclick.y
.FIRSTY
.- HEIGHT1
.=> TEMP
.point_source
.fast_click SRCX SRCY
.end_snap
.fast_click FIRSTX TEMP
.FIRSTY
.+ HEIGHT1
.=> TEMP
.end_snap
.fast_click FIRSTX TEMP
.new_text
Do you want an object line dropped onto the axis?
.yes_no OBJECT NOOBJECT
:OBJECT
.object_coordinates LENS1 0 focus
.X
.- FIRSTX
./ 2
.+ FIRSTX
.=> X
.tapemeasure
.end_snap
.fast_click SRCX SRCY
.red_rays 0
.perp_snap
.fast_click X Y
.=> OBJECT
.red_rays 1
.select_object OBJECT
.tapemeasure_options 1 1 noleader none
.unselect_all
.goto NOOBJECT
:PLANE
.new_text
Click at a point where you want the ray that passes through the
centre of the first lens to come from.
.user_click
.SRCX lastclick.x
.SRCY lastclick.y
.SRCY
.+ HEIGHT1
.=> TEMP
.plane_source
.fast_click SRCX TEMP
.FIRSTY
.+ HEIGHT1
.=> TEMP
.end_snap
.fast_click FIRSTX TEMP
.FIRSTY
.- HEIGHT1
.=> TEMP
.end_snap
.fast_click FIRSTX TEMP
:NOOBJECT
:ADJUST
.unselect_all
.new_text
Choose one of the following actions by clicking on the
appropriate button.

A - Modify the lenses

B - Move the source of rays

C - Create forward or back projections of rays

D - To close the script
.choose 4 A B C D
:A
.call modlens.rsc
.goto ADJUST
:B
.new_text
Click on the primary mouse button when you are finished.
.PLANESRC
.if!= 0 PLANE1
.fast_click SRCX SRCY
.call onlyrays.rsc
.fast_click SRCX SRCY
.fast_move SRCX SRCY
.user_click
.SRCX lastclick.x
.SRCY lastclick.y
.goto ADJUST
:PLANE1
.ray_of_source 0 0
.=> RAY
.object_coordinates 0 start
.fast_click X Y
.call onlyrays.rsc
.fast_click X Y
.SRCY
.+ HEIGHT1
.=> SRCY
.fast_move SRCX SRCY
.user_click
.SRCX lastclick.x
.SRCY lastclick.y
.SRCY
.- HEIGHT1
.=> SRCY
.goto ADJUST
:C
.call fbproj.rsc
.goto ADJUST
:D
:END
.enable_undo 1
.quiet_snap 0
.new_text

.return
